
/* RTF parser declarations */

int ecRtfParse(FILE *fp);
int ecGCFParse(FILE *fp);
int ecPushRtfState(void);
int ecPopRtfState(void);
int ecParseRtfKeyword(FILE *fp);
int ecParseChar(int c);
int ecTranslateKeyword(char *szKeyword, long param);
int ecPrintChar(int ch, int stream);
int ecEndGroupAction(void);
int ecChangeDest(int isym, long param);
int ecParseSpecialKeyword(IPFN ipfn);
int ecParseHexByte(void);
int ecPrintHTMLchar(int ch, int out_stream);
int ecPrintHTMLint(int number, int out_stream);
int ecPrintHTMLhex(long number, int out_stream);
int ecPrintHTMLlong(long number, int out_stream);
int ecPrintHTMLstring(char * s, int out_stream);
void printFont(int font_no);
void printSection (int section_no);
int addmetaHTML(int meta_type, long meta_value);
int replacemetaHTML(int meta_type, int HTMLposition);
int printHTMLline(bool inside_index, int out_stream);
int printHTMLlinebody(int out_stream);
int printHTMLhead(bool inside_index, int out_stream);
int HTMLmatchbrackets(bool full_match);
int HTMLnoalignbrackets(int org_metahtml);
int HTMLnormalize(void);
long change_font_size (long param);
int openHTMLfile(int out_stream);
int closeHTMLfile(bool last_slide, int out_stream);
int read_configuration(void);
int printHTMLindex(void);
char itoc(int i);
char htoc(int i);
char * try_open_files(
	int file_number,
	char * prefix1, char * prefix2,
	char * suffix1, char * suffix2, char * suffix3, char * suffix4);
char * try_open_file(int file_number, char * prefix, char * suffix);
int slash_position(char * in_string);
int print_copyfiles(void);
void HTMLmagicchar(int isym, int ch, char * magicchars);
int ecmove_abstract(void);
void corecheck(void);
int addingEndToPTag(void);
bool compare_old(char * s1, char * s2);

/* RTF variable declarations */

extern int cGroup;
extern RDS rds;
extern RIS ris;

extern SAVE *psave;
extern long cbBin;
extern long lParam;
extern bool fSkipDestIfUnk;
extern FILE *fpIn;
extern FILE *fpOUT;
extern FILE *fpErr;

extern int  Script_Type;

#define DOS 1
#define UNIX 2

extern long	rtf_version;			/*RTF version number*/
extern bool 	insideFontBl;			/*Inside Font definition*/
extern bool 	insideStyleSheet;		/*Inside Section definition*/
extern bool	run_endGroup;			/*PAR detected, closing HTML line*/
extern int 	font_no;			/*Current font number*/
extern int 	section_no;			/*Current section number*/
extern int 	name_position;			/*Current position in font and section names*/
extern FONT_DEF	fonts_table[max_font];		/*font definitions*/
extern SECT_DEF	section_table[max_section];	/*headings definitions*/
extern char 	HTML_paragraph[max_line];	/*one Meta-HTML paragraph*/
extern long	HTML_parameters[max_line];	/*corresponding Meta-HTML parameters*/
extern int	HTML_position;			/*position in HTML line*/
extern int	max_HTML_position;
extern bool	par_detected;			/*RTF /par command detected*/
extern char *	HTMLcommands[256];		/*HTML commands corresponding to metahtml*/
extern int	HEADcharset;			/*Charset number*/
extern HTML	html_state;			/*State of HTML output*/
extern int	html_file_number;		/*Number of output file*/
extern char	inputfile[max_string];      	/*Name of the RTF file*/
extern char	outputdirectory[max_string];    /*Name of the output directory*/
extern char	index_file_name[max_string];	/*File INDEX.HTM*/
extern char	outputstyle[max_string];	/*Name of the output style:bullets, tables, paragraphs*/
extern O_STYLE  o_style;			/*Output style as integer*/
extern int	font_scaling;			/*Scaling as percentage*/
extern FONT_FAM	font_family;			/*Windows/ISO*/
extern bool	links;                          /*True - Powerpoint-like output*/
extern char	previous[max_string];		/*Texts for links in PowerPoint-like output*/
extern char	next[max_string];
extern char	graphics[max_string];
extern char	contents[max_string];
extern char	texts[max_string];
extern int	image_width;
extern int	image_height;
extern int	icon_width;
extern int	icon_height;
extern RTF_GCF	rtf_gcf;
extern int      section_level;


#define byname	1
#define bylabel	2
extern int	Foil_Missing;


extern int	gcfsymMax;
extern GCF_SYM  rgsymGCF[];
extern char *	foil_titles[max_title];  	/*titles of foils*/
extern bool	foil_images[max_title];		/*fTRUE - image file found*/
extern bool *	foil_imagefiles[max_title];	/*names of files with images*/

extern bool	warnings;

/* RTF parser error codes */

#define ecOK 0                      /* Everything's fine!*/
#define ecStackUnderflow    1       /* Unmatched '}'*/
#define ecStackOverflow     2       /* Too many '{' -- memory exhausted*/
#define ecUnmatchedBrace    3       /* RTF ended during an open group.*/
#define ecInvalidHex        4       /* invalid hex character found in data*/
#define ecBadTable          5       /* RTF table (sym or prop) invalid*/
#define ecAssertion         6       /* Assertion failure*/
#define ecEndOfFile         7       /* End of file reached while reading RTF*/
#define ecHTMLnomemory	    8	    /* no memory for meta-HTML command*/
#define ecCannotOpenFile    9	    /* cannot open file to write */
#define ecbadwrite	    10	    /* cannot write to an open file */

#define ecGCFcommandtoolong  	   101	    /*GCF command name too long to be precessed*/
#define ecGCFcommandnotrecognized  102	    /*line with no ":" after GCF command*/
#define ecGCFargumenttoolong	   103	    /*GCF argument too long*/
#define ecgcfnoEndFoil		   104	    /*no EndFoil after BeginFoil*/
#define ecgcfnoBeginFoil	   105	    /*no beginFoil before EndFoil*/
#define ecgcfnoBeginAnnotation	   106	    /*no begin annotation before endAnnotation*/
#define ecgcfnoFoilNumber	   107	    /*END instead of foil numnbers*/
